searchNodes=[{"ref":"Graphqexl.html","title":"Graphqexl","type":"module","doc":"Fully-loaded GraphQL implementation with server and developer tools. Schema Schemas can be expressed as gql DSL syntax, a JSON document, or by building up a %Graphqexl.Schema struct via calls to Graphql.Schema.register/2. Resolvers Resolvers are functions that are invoked to fulfill query executions. They can take parameters, as expressed as query arguments in the schema, and must return a type coercible to the type specified in the schema. Installation The package can be installed by adding graphqexl to your list of dependencies in mix.exs: def deps do [ {:graphqexl, &quot;~&gt; 0.1.0&quot;} ] end Support / Maintenance graphqexl uses Semantic Versioning, contained in a VERSION file. During the 0.X release series, we will support 2 minor versions back from the current at any given time. For example, if the current latest release is 0.4, we will also support 0.3 and 0.2, but not 0.1. On the 1.Y and greater tracks, we will support one minor version at a time of one major version back from the current. For example, if the latest release is 2.3 and there was a 1.7 release and 0.9 release, we will support 2.3 and 1.7, but not 2.2, 1.6, or 0.9. Development Requirements Elixir 1.9+ / Erlang 22+: brew install erlang elixir / apt-get install erlang elixir Hex: mix local.hex Mix Dependencies: mix deps.get (and optionally mix deps.compile) TODO: Contributing Git Branching Branches should follow git-flow conventions. master master is the current, latest stable release. There will be a corresponding tag for the version. This is what is published to Hex. develop develop is the primary branch, and is what will be deployed to staging environments. feature branches Feature branches are primarily what developers work on and are prefixed with feature/. They are cut from develop and merge back into develop. Developers should rebase feature branches frequently against develop. release branches Release branches are cut from develop and merged into master, which is then back-merged into develop. The VERSION file will be incremented in these branches, and contain one or more feature branches ready to be released. hotfix branches Hotfix branches are Z-version patch updates containing critical or non-critical bug and security fixes. They may also contain dependency updates. These branches are prefixed hotfix/ and named for their version. The VERSION file will be updated in these branches. Hotfix branches are cut from master, merged into master and then master is back-merged into develop and any active release branches. support branches Support branches are cut from master before X-version major releases are made. See the Support/Maintenance section for more details on maintenance policies. Support branches are prefixed with support/ and named for their X or X.Y track. They are versioned, tagged and published separately, almost like secondary &quot;master&quot;s. Release branches are merged into support branches as appropriate per the support track&#39;s status. Documentation can be found at https://hexdocs.pm/graphqexl. References GraphQL GraphQL Spec"},{"ref":"Graphqexl.Query.html","title":"Graphqexl.Query","type":"module","doc":"GraphQL query, comprised of one or more Graphqexl.Query.Operation.t/0s. Built by calling parse/1 with either a Graphqexl.Query.gql/0 string (see Graphqexl.Schema.Dsl) or Graphqexl.Query.json/0."},{"ref":"Graphqexl.Query.html#execute/2","title":"Graphqexl.Query.execute/2","type":"function","doc":"Execute the given Graphqexl.Query.t/0 Returns: Graphqexl.Query.ResultSet.t/0"},{"ref":"Graphqexl.Query.html#parse/1","title":"Graphqexl.Query.parse/1","type":"function","doc":"Parse the given json map into a Graphqexl.Query.t/0 Returns: Graphqexl.Query.t/0"},{"ref":"Graphqexl.Query.html#t:gql/0","title":"Graphqexl.Query.gql/0","type":"type","doc":""},{"ref":"Graphqexl.Query.html#t:json/0","title":"Graphqexl.Query.json/0","type":"type","doc":""},{"ref":"Graphqexl.Query.html#t:t/0","title":"Graphqexl.Query.t/0","type":"type","doc":""},{"ref":"Graphqexl.Query.Operation.html","title":"Graphqexl.Query.Operation","type":"module","doc":"Individual operation contained in a query"},{"ref":"Graphqexl.Query.Operation.html#t:t/0","title":"Graphqexl.Query.Operation.t/0","type":"type","doc":""},{"ref":"Graphqexl.Query.ResultSet.html","title":"Graphqexl.Query.ResultSet","type":"module","doc":"Result of a GraphQL operation, including any errors"},{"ref":"Graphqexl.Query.ResultSet.html#t:t/0","title":"Graphqexl.Query.ResultSet.t/0","type":"type","doc":""},{"ref":"Graphqexl.Query.Validator.html","title":"Graphqexl.Query.Validator","type":"module","doc":"Validate a given query against a given schema"},{"ref":"Graphqexl.Query.Validator.html#valid?/2","title":"Graphqexl.Query.Validator.valid?/2","type":"function","doc":"Check whether a query is valid in a given schema Returns: t:boolean"},{"ref":"Graphqexl.Schema.html","title":"Graphqexl.Schema","type":"module","doc":"Structured representation of a GraphQL schema, either built dynamically or parsed from a JSON document or GQL string."},{"ref":"Graphqexl.Schema.html#gql/1","title":"Graphqexl.Schema.gql/1","type":"function","doc":"Parses a json map into a Graphqexl.Schema.t/0. Returns Graphqexl.Schema.t/0"},{"ref":"Graphqexl.Schema.html#register/2","title":"Graphqexl.Schema.register/2","type":"function","doc":"Registers the given component on the given schema. Returns Graphqexl.Schema.t/0"},{"ref":"Graphqexl.Schema.html#t:component/0","title":"Graphqexl.Schema.component/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.html#t:gql/0","title":"Graphqexl.Schema.gql/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.html#t:json/0","title":"Graphqexl.Schema.json/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.html#t:t/0","title":"Graphqexl.Schema.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Argument.html","title":"Graphqexl.Schema.Argument","type":"module","doc":"GraphQL argument, belonging to e.g. a Query or Mutation"},{"ref":"Graphqexl.Schema.Argument.html#t:t/0","title":"Graphqexl.Schema.Argument.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Dsl.html","title":"Graphqexl.Schema.Dsl","type":"module","doc":"Domain-Specific Language for expressing and parsing a GQL string as a Graphqexl.Schema.t/0"},{"ref":"Graphqexl.Schema.Dsl.html#enum/3","title":"Graphqexl.Schema.Dsl.enum/3","type":"function","doc":"Creates a new enum from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#interface/3","title":"Graphqexl.Schema.Dsl.interface/3","type":"function","doc":"Creates a new interface from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#mutation/2","title":"Graphqexl.Schema.Dsl.mutation/2","type":"function","doc":"Creates a new mutation from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#preprocess/1","title":"Graphqexl.Schema.Dsl.preprocess/1","type":"function","doc":"Prepares the graphql schema dsl string for parsing Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#query/2","title":"Graphqexl.Schema.Dsl.query/2","type":"function","doc":"Creates a new query from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#schema/2","title":"Graphqexl.Schema.Dsl.schema/2","type":"function","doc":"Creates a new schema from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#subscription/2","title":"Graphqexl.Schema.Dsl.subscription/2","type":"function","doc":"Creates a new subscription from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#type/3","title":"Graphqexl.Schema.Dsl.type/3","type":"function","doc":"Creates a new type from the given spec Returns %Graphqexl.Schema{} TODO: docstring examples"},{"ref":"Graphqexl.Schema.Dsl.html#union/4","title":"Graphqexl.Schema.Dsl.union/4","type":"function","doc":"Creates a new union from the given spec Returns Graphqexl.Schema.t/0 TODO: docstring examples"},{"ref":"Graphqexl.Schema.Field.html","title":"Graphqexl.Schema.Field","type":"module","doc":"GraphQL field, belonging to e.g. a Type or Interface"},{"ref":"Graphqexl.Schema.Field.html#t:t/0","title":"Graphqexl.Schema.Field.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Interface.html","title":"Graphqexl.Schema.Interface","type":"module","doc":"GraphQL Interface, encapsulating a group of fields to be shared between types"},{"ref":"Graphqexl.Schema.Interface.html#fields/1","title":"Graphqexl.Schema.Interface.fields/1","type":"function","doc":"Lists the available fields on the given interface. Returns: [t:Graphqexl.Schema.Field.t/0]"},{"ref":"Graphqexl.Schema.Interface.html#t:t/0","title":"Graphqexl.Schema.Interface.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Mutation.html","title":"Graphqexl.Schema.Mutation","type":"module","doc":"GraphQL mutation"},{"ref":"Graphqexl.Schema.Mutation.html#t:t/0","title":"Graphqexl.Schema.Mutation.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Query.html","title":"Graphqexl.Schema.Query","type":"module","doc":"GraphQL query"},{"ref":"Graphqexl.Schema.Query.html#t:t/0","title":"Graphqexl.Schema.Query.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Ref.html","title":"Graphqexl.Schema.Ref","type":"module","doc":"Ref struct, representing a connection to another user-defined type (that may not yet actually be defined in the run-time context)"},{"ref":"Graphqexl.Schema.Ref.html#fields/1","title":"Graphqexl.Schema.Ref.fields/1","type":"function","doc":"Returns a list of the fields available on the type resolved to by the given ref. Returns: [t:Graphqexl.Schema.Field.t/0]"},{"ref":"Graphqexl.Schema.Ref.html#resolve/1","title":"Graphqexl.Schema.Ref.resolve/1","type":"function","doc":"Resolves the given Graphqexl.Schema.Ref.t/0 into its corresponding Graphqexl.Schema.Ref.component/0 Returns: Graphqexl.Schema.Ref.t/0"},{"ref":"Graphqexl.Schema.Ref.html#t:component/0","title":"Graphqexl.Schema.Ref.component/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Ref.html#t:t/0","title":"Graphqexl.Schema.Ref.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Required.html","title":"Graphqexl.Schema.Required","type":"module","doc":"Wrapper struct indicating the wrapped type is required on its parent"},{"ref":"Graphqexl.Schema.Required.html#fields/1","title":"Graphqexl.Schema.Required.fields/1","type":"function","doc":"Lists the fields available on the required type. Returns: [t:Graphqexl.Schema.Field.t/0]"},{"ref":"Graphqexl.Schema.Required.html#t:t/0","title":"Graphqexl.Schema.Required.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Subscription.html","title":"Graphqexl.Schema.Subscription","type":"module","doc":"GraphQL subscription"},{"ref":"Graphqexl.Schema.Subscription.html#t:t/0","title":"Graphqexl.Schema.Subscription.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.TEnum.html","title":"Graphqexl.Schema.TEnum","type":"module","doc":"GraphQL enum"},{"ref":"Graphqexl.Schema.TEnum.html#values/1","title":"Graphqexl.Schema.TEnum.values/1","type":"function","doc":"Lists the values available on the given Graphqexl.Schema.TEnum.t/0. Returns: [t:atom]"},{"ref":"Graphqexl.Schema.TEnum.html#t:t/0","title":"Graphqexl.Schema.TEnum.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Type.html","title":"Graphqexl.Schema.Type","type":"module","doc":"GraphQL type"},{"ref":"Graphqexl.Schema.Type.html#fields/1","title":"Graphqexl.Schema.Type.fields/1","type":"function","doc":"Lists the fields available on the given Graphqexl.Schema.Type.t/0. Returns: [t:Graphqexl.Schema.Field.t/0]"},{"ref":"Graphqexl.Schema.Type.html#t:t/0","title":"Graphqexl.Schema.Type.t/0","type":"type","doc":""},{"ref":"Graphqexl.Schema.Union.html","title":"Graphqexl.Schema.Union","type":"module","doc":"GraphQL union"},{"ref":"Graphqexl.Schema.Union.html#fields/1","title":"Graphqexl.Schema.Union.fields/1","type":"function","doc":"Lists the fields available on the given Graphqexl.Schema.Union.t/0. Returns: [t:Graphqexl.Schema.Field.t/0]"},{"ref":"Graphqexl.Schema.Union.html#t:t/0","title":"Graphqexl.Schema.Union.t/0","type":"type","doc":""},{"ref":"Mix.Tasks.Dev.html","title":"Mix.Tasks.Dev","type":"task","doc":"[STUB] Run a development server with the specified schema file"},{"ref":"Mix.Tasks.Dev.html#run/1","title":"Mix.Tasks.Dev.run/1","type":"function","doc":"Run the dev server ARGS: schema_file: file path where the schema is defined"},{"ref":"Mix.Tasks.Docker.Build.html","title":"Mix.Tasks.Docker.Build","type":"task","doc":"Build the application&#39;s Docker Image"},{"ref":"Mix.Tasks.Docker.Build.html#run/1","title":"Mix.Tasks.Docker.Build.run/1","type":"function","doc":"Build the application&#39;s Docker image ARGS image_name, string, e.g.: &quot;graphqexl&quot; image_repo, string, e.g.: &quot;gcr.io/absynthe&quot; release_name, string, e.g.: &quot;stable&quot;"},{"ref":"Mix.Tasks.Docker.Publish.html","title":"Mix.Tasks.Docker.Publish","type":"task","doc":"Publish the built application container to the given image repo"},{"ref":"Mix.Tasks.Docker.Publish.html#run/1","title":"Mix.Tasks.Docker.Publish.run/1","type":"function","doc":"Publish the built application container to the given image repo ARGS image_name, string, e.g.: &quot;graphqexl&quot; image_repo, string, e.g.: &quot;gcr.io/graphqexl&quot; image_tag, string, e.g.: &quot;latest&quot;"},{"ref":"Mix.Tasks.Lint.html","title":"Mix.Tasks.Lint","type":"task","doc":"Perform linting and static analysis using Lefthook as a runner for tools like Credo"},{"ref":"Mix.Tasks.Lint.html#run/1","title":"Mix.Tasks.Lint.run/1","type":"function","doc":"Perform linting and static analysis using Lefthook as a runner for tools like Credo"},{"ref":"Treex.Traverse.html","title":"Treex.Traverse","type":"module","doc":"Basic tree traversal algoritms. It implements depth-first and breadth-first traverse algorithms"},{"ref":"Treex.Traverse.html#traverse/3","title":"Treex.Traverse.traverse/3","type":"function","doc":"Main function. You need to pass the tree structure, the function operation and the algorithm to use. An operation function must have the type: (any, any, history -&gt; result) with the form: fn value, key, history -&gt; body end where value and key are the node&#39;s values and keys, and history is the accumulated list of traverse operated nodes. Returns list with the result of the operation on each node Examples iex&gt; Treex.TreeTraversal.traverse(nil, fn x, , -&gt; {:continue, x} end, :bfs) [] iex&gt; Treex ..(1)&gt; .Traverse ..(1)&gt; .traverse(%Treex.Tree{value: 1, ..(1)&gt; children: [%Treex.Tree{value: 2}, ..(1)&gt; %Treex.Tree{value: 3}, ..(1)&gt; %Treex.Tree{value: 4}]}, ..(1)&gt; fn x, , -&gt; {:continue, x} end, ..(1)&gt; :bfs) [4, 3, 2, 1]"},{"ref":"Treex.Traverse.html#tree_insert/2","title":"Treex.Traverse.tree_insert/2","type":"function","doc":""},{"ref":"Treex.Traverse.html#t:collection/0","title":"Treex.Traverse.collection/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:history/0","title":"Treex.Traverse.history/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:operation/0","title":"Treex.Traverse.operation/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:queue/0","title":"Treex.Traverse.queue/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:result/0","title":"Treex.Traverse.result/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:stack/0","title":"Treex.Traverse.stack/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:traverse/0","title":"Treex.Traverse.traverse/0","type":"type","doc":""},{"ref":"Treex.Traverse.html#t:tree/0","title":"Treex.Traverse.tree/0","type":"type","doc":""},{"ref":"Treex.Tree.html","title":"Treex.Tree","type":"module","doc":""},{"ref":"Treex.Tree.html#t:t/0","title":"Treex.Tree.t/0","type":"type","doc":""},{"ref":"graphql_architecture.html","title":"graphql_architecture","type":"extras","doc":""},{"ref":"graphql_architecture.html#schema","title":"graphql_architecture - Schema","type":"extras","doc":"Schemas can be expressed as Graphqexl.Schema.gql/0 DSL syntax, a JSON document, or by building up a Graphqexl.Schema.t/0 struct via calls to Graphql.Schema.register/2."},{"ref":"graphql_architecture.html#resolvers","title":"graphql_architecture - Resolvers","type":"extras","doc":"Resolvers are functions that are invoked to fulfill query executions. They can take parameters, as expressed as query arguments in the schema, and must return a type coercible to the type specified in the schema."}]